'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = buildAssertion;

var _assert = require('assert');

var _assert2 = _interopRequireDefault(_assert);

var _pick_matching = require('./pick_matching');

var _pick_matching2 = _interopRequireDefault(_pick_matching);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function buildAssertion(name, baseAssertion) {

    return function assertion(actual, expected, message) {

        var matched = (0, _pick_matching2.default)(actual, expected);

        try {
            baseAssertion(matched, expected, message);
        } catch (e) {

            throw new _assert2.default.AssertionError({
                actual: matched,
                expected: expected,
                operator: name,
                stackStartFunction: assertion
            });
        }
    };
}